<?php
	require 'mdp.php';
	
	@list($from) = file('../config.from.txt', FILE_IGNORE_NEW_LINES);
	define('FROM', $from);
	
	if (isset($_POST['head'])) {
		$head = (array)$_POST['head'];
		
		$from = trim(@$head['From']);
		if (preg_match('/<([^>]+)>/', $from, $m))
			$from = $m[1];
		@list(, $fromdomain) = explode('@', $from, 2);
		
		//$mid = uniqid('courriel.', true) . "@" . $fromdomain;
		// https://www.jwz.org/doc/mid.html
		$rdmid = strtoupper(base_convert((string)time(), 10, 36) . '.' . base_convert(bin2hex(random_bytes(8)), 16, 36));
		$mid = $rdmid . '@' . $fromdomain;
		
		$tos = array_filter(preg_split('/\s*,\s*/', trim(@$head['To'])));
		foreach ($tos as &$to) {
			if (preg_match('/<([^>]+)>/', $to, $m))
				$to = $m[1];
		}
		unset($to);
		$domains = array();
		foreach ($tos as $to) {
			@list(, $domain) = explode('@', $to, 2);
			if ($domain)
				$domains[$domain][] = $to;
		}
		
		$head['Subject'] = substr(iconv_mime_encode('', (string)@$head['Subject']), 2);
		
		$data = '';
		foreach ($head as $key => $value) {
			$data .= $key . ': ' . $value . "\r\n";
		}
		$data .= "Mime-Version: 1.0 (1.0)\r\n";
		$data .= "Message-Id: <$mid>\r\n";
		
		$files = array();
		foreach ((array)@$_FILES['attachment']['name'] as $i => $name) {
			if ($_FILES['attachment']['error'][$i])
				continue;
			$test = "Content-Type: " . @$_FILES['attachment']['type'][$i] . "; name=\"$name\"\r\n";
			$test .= "Content-Transfer-Encoding: base64\r\n";
			$test .= "Content-Disposition: attachment; filename=\"$name\"\r\n";
			$test .= "\r\n";
			$test .= wordwrap(base64_encode(@file_get_contents($_FILES['attachment']['tmp_name'][$i])), 70, "\r\n", true);
			$files[$name] = $test;
		}
		
		$boundary = uniqid('courriel-', true);
		if ($files) {
			$data .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\r\n";
			$data .= "\r\n";
			$data .= "\r\n--$boundary\r\n";
		}
		
		$data .= "Content-Type: text/plain; charset=utf-8\r\n";
		$data .= "Content-Transfer-Encoding: quoted-printable\r\n";
		$data .= "\r\n";
		$data .= quoted_printable_encode(@$_POST['body']);
		//$data = str_replace("\r\nFrom ", "\r\n=46rom ", $data);
		$data = preg_replace("@\r\n(>*)From @", "\r\n\\1=46rom ", $data);
		
		if ($files) {
			foreach ($files as $file) {
				$data .= "\r\n--$boundary\r\n";
				$data .= $file;
			}
			$data .= "\r\n--$boundary--\r\n";
		} else
			$data .= "\r\n";
		
		//die('<meta charset=utf-8><plaintext>' . $data/* . print_r($_FILES, true) . print_r($files, true)*/);
		
		$mbox = "From <$from> " . date('Y-m-d H:i:s') . "\r\n" . str_replace("\r\nFrom ", "\r\n>From ", $data) . "\r\n";
		file_put_contents('../sent/sent.txt', $mbox, LOCK_EX | FILE_APPEND);
		file_put_contents('../sent/sent/' . $mid . '.eml', $mbox);
		foreach ($domains as $domain => $tos) {
			//continue;
			if (!getmxrr($domain, $hosts))
				continue;
			if ($fp = stream_socket_client('tcp://' . $hosts[0] . ':25', $eno, $estr, 30)) {
				fgets($fp);
				fwrite($fp, "HELO $fromdomain\r\n");
				fgets($fp);
				fwrite($fp, "MAIL FROM:<$from>\r\n");
				fgets($fp);
				foreach ($tos as $to) {
					fwrite($fp, "RCPT TO:<$to>\r\n");
					fgets($fp);
				}
				fwrite($fp, "DATA\r\n");
				fgets($fp);
				fwrite($fp, str_replace("\r\n.", "\r\n..", $data));
				fwrite($fp, ".\r\n");
				fgets($fp);
				fwrite($fp, "QUIT\r\n");
				fgets($fp);
				fclose($fp);
			}
		}
		header('Location: send.php');
		die();
	}
?>
<!doctype html>
<meta charset=utf-8 />
<meta content=width=device-width name=viewport />
<link href=style/sheet.css rel=stylesheet />
<style>
	textarea,
	td input {
		box-sizing: border-box;
		width: 100%;
	}
	textarea {
		min-height: 20em;
		resize: vertical;
	}
</style>
<title>Envoi de courriel</title>
<form method=post>
	<p><button name=_logout style="float: right; ">Logout</button></p>
</form>
<h1>Envoi de courriel</h1>
<form enctype=multipart/form-data method=post onsubmit="return this.send.checked">
	<table border=1 cellpadding=10 width=100%>
		<tr>
			<td align=right nowrap width=1>From</td>
			<td align=left><input name=head[From] value="<?= htmlspecialchars(FROM) ?>" /></td>
		</tr>
		<tr>
			<td align=right nowrap width=1>To</td>
			<td align=left><input name=head[To] value="<?= htmlspecialchars(@$_GET['to']) ?>" /></td>
		</tr>
		<tr>
			<td align=right nowrap width=1>Date</td>
			<td align=left><input name=head[Date] value="<?= htmlspecialchars(date(DATE_RFC1123)) ?>" /></td>
		</tr>
		<tr>
			<td align=right nowrap width=1>Subject</td>
			<td align=left><input name=head[Subject] value="<?= htmlspecialchars(@$_GET['subject']) ?>" /></td>
		</tr>
<?php if (isset($_GET['in-reply-to'])): ?>
		<tr>
			<td align=right nowrap width=1>In-Reply-To</td>
			<td align=left><input name=head[In-Reply-To] value="<?= htmlspecialchars($_GET['in-reply-to']) ?>" /></td>
		</tr>
<?php endif; ?>
	</table>
	<p><textarea name=body>
<?= htmlspecialchars(@$_GET['body']) ?>
</textarea>
	<p><input multiple name=attachment[] type=file />
	<p><input name=send type=checkbox /> <button>Send</button>
</form>
